diff --git a/src/modules/FFmpeg/FormatContext.cpp b/src/modules/FFmpeg/FormatContext.cpp
index 1809fd2e..5fad479b 100644
--- a/src/modules/FFmpeg/FormatContext.cpp
+++ b/src/modules/FFmpeg/FormatContext.cpp
@@ -25,6 +25,8 @@
 #include <Settings.hpp>
 #include <Packet.hpp>
 
+#include <cmath>
+
 #ifdef Q_OS_ANDROID
 #   include <QFile>
 #endif
@@ -226,7 +228,7 @@ public:
     }
 
 private:
-    void run() override
+    void run()
     {
         avformat_open_input(&m_formatCtx, m_url, m_inputFmt, &m_options);
         if (!wakeIfNotAborted() && m_formatCtx)
@@ -262,7 +264,7 @@ FormatContext::~FormatContext()
         av_packet_free(&packet);
     }
     delete oggHelper;
-    for (StreamInfo *streamInfo : std::as_const(streamsInfo))
+    for (StreamInfo *streamInfo : streamsInfo)
         delete streamInfo;
 }
 
@@ -1001,7 +1003,7 @@ bool FormatContext::open(const QString &_url, const QString &param)
                 {
                     if (firstAudioIdx > -1)
                     {
-                        for (auto &&streamInfo : std::as_const(streamsInfo))
+                        for (auto &&streamInfo : streamsInfo)
                         {
                             if (streamInfo->params->codec_type == AVMEDIA_TYPE_AUDIO)
                                 streamInfo->is_default = false;
@@ -1034,7 +1036,7 @@ void FormatContext::setStreamOffset(double offset)
 void FormatContext::selectStreams(const QSet<int> &selectedStreams)
 {
     m_allDiscarded = true;
-    for (AVStream *stream : std::as_const(streams))
+    for (AVStream *stream : streams)
     {
         if (stream->codecpar->codec_type == AVMEDIA_TYPE_DATA || stream->codecpar->codec_type == AVMEDIA_TYPE_ATTACHMENT)
         {
@@ -1092,7 +1094,7 @@ StreamInfo *FormatContext::getStreamInfo(AVStream *stream) const
 
     bool hasUrlTagDefault = false;
     bool hasUrlTagLanguage = false;
-    for (auto &&urlTag : std::as_const(m_urlTags))
+    for (auto &&urlTag : m_urlTags)
     {
         const auto tag = StreamInfo::getTag(urlTag.first);
         if (tag == QMPLAY2_TAG_DEFAULT)
@@ -1170,7 +1172,7 @@ StreamInfo *FormatContext::getStreamInfo(AVStream *stream) const
             {
                 const auto rotation = av_display_rotation_get(reinterpret_cast<const int32_t *>(sideData));
 #endif
-                if (!qIsNaN(rotation))
+                if (!std::isnan(rotation))
                 {
                     switch(qRound(rotation))
                     {
diff --git a/src/modules/FFmpeg/VAAPI.cpp b/src/modules/FFmpeg/VAAPI.cpp
index 4ceed4bb..21ea7f84 100644
--- a/src/modules/FFmpeg/VAAPI.cpp
+++ b/src/modules/FFmpeg/VAAPI.cpp
@@ -34,9 +34,8 @@ extern "C"
     #include <libavutil/buffer.h>
 }
 
-#include <QGuiApplication>
+#include <QApplication>
 #include <QVarLengthArray>
-#include <QVersionNumber>
 #include <QFileInfo>
 #include <QDebug>
 #include <QDir>
@@ -148,16 +147,17 @@ bool VAAPI::open()
         // Some issues discussed here: https://gitlab.freedesktop.org/mesa/mesa/-/issues/8740
 
         const auto parts = m_vendor.simplified().split(" ");
-        for (auto &&part : parts)
+        // Qt4: No std::as_const, no for-range with auto&&
+        foreach (const QString &part, parts)
         {
-            const auto ver = QVersionNumber::fromString(part);
+            const auto ver = SimpleVersion::fromString(part);
             if (!ver.isNull())
             {
                 m_driverVersion = ver;
                 break;
             }
         }
-        if (m_driverVersion >= QVersionNumber(22, 0, 0) && m_driverVersion < QVersionNumber(23, 3, 0))
+        if (m_driverVersion >= SimpleVersion(22, 0, 0) && m_driverVersion < SimpleVersion(23, 3, 0))
         {
             m_mutex = std::make_unique<QMutex>();
         }
diff --git a/src/modules/FFmpeg/VAAPI.hpp b/src/modules/FFmpeg/VAAPI.hpp
index 6cfbce48..229d8476 100644
--- a/src/modules/FFmpeg/VAAPI.hpp
+++ b/src/modules/FFmpeg/VAAPI.hpp
@@ -19,7 +19,6 @@
 #pragma once
 
 #include <QCoreApplication>
-#include <QVersionNumber>
 #include <QVector>
 #include <QMutex>
 #include <QHash>
@@ -34,6 +33,44 @@ struct AVFrame;
 class QImage;
 class Frame;
 
+// Qt4: Simple version number replacement
+struct SimpleVersion
+{
+    int major = 0, minor = 0, patch = 0;
+
+    SimpleVersion() = default;
+    SimpleVersion(int maj, int min, int pat) : major(maj), minor(min), patch(pat) {}
+
+    bool isNull() const { return major == 0 && minor == 0 && patch == 0; }
+
+    bool operator>=(const SimpleVersion &other) const
+    {
+        if (major != other.major) return major > other.major;
+        if (minor != other.minor) return minor > other.minor;
+        return patch >= other.patch;
+    }
+
+    bool operator<(const SimpleVersion &other) const
+    {
+        return !(*this >= other) && !(*this == other);
+    }
+
+    bool operator==(const SimpleVersion &other) const
+    {
+        return major == other.major && minor == other.minor && patch == other.patch;
+    }
+
+    static SimpleVersion fromString(const QString &str)
+    {
+        SimpleVersion ver;
+        QStringList parts = str.split('.');
+        if (parts.size() >= 1) ver.major = parts[0].toInt();
+        if (parts.size() >= 2) ver.minor = parts[1].toInt();
+        if (parts.size() >= 3) ver.patch = parts[2].toInt();
+        return ver;
+    }
+};
+
 class VAAPI
 {
     Q_DECLARE_TR_FUNCTIONS(VAAPI)
@@ -69,7 +106,7 @@ public:
 
     QString m_vendor;
     bool m_isMesaRadeon = false;
-    QVersionNumber m_driverVersion; // Used for Mesa Radeon workarounds
+    SimpleVersion m_driverVersion; // Used for Mesa Radeon workarounds
 
     bool ok = false;
 
diff --git a/src/modules/FFmpeg/VAAPIOpenGL.cpp b/src/modules/FFmpeg/VAAPIOpenGL.cpp
index bcabebad..da5a8966 100644
--- a/src/modules/FFmpeg/VAAPIOpenGL.cpp
+++ b/src/modules/FFmpeg/VAAPIOpenGL.cpp
@@ -22,7 +22,7 @@
 #include <QMPlay2Core.hpp>
 #include <Frame.hpp>
 
-#include <QOpenGLContext>
+#include <QtOpenGL/QGLContext>
 
 #include <unistd.h>
 
@@ -90,7 +90,8 @@ bool VAAPIOpenGL::init(const int *widths, const int *heights, const SetTexturePa
     if (m_egl->eglDpy != EGL_NO_DISPLAY && m_egl->eglCreateImageKHR && m_egl->eglDestroyImageKHR && m_egl->glEGLImageTargetTexture2DOES)
         return true;
 
-    const auto context = QOpenGLContext::currentContext();
+    // Qt4: Use QGLContext instead of QOpenGLContext
+    const auto context = QGLContext::currentContext();
     if (!context)
     {
         QMPlay2Core.logError("VA-API :: Unable to get OpenGL context");
diff --git a/src/modules/FFmpeg/VAAPIOpenGL.hpp b/src/modules/FFmpeg/VAAPIOpenGL.hpp
index 71982f09..41927153 100644
--- a/src/modules/FFmpeg/VAAPIOpenGL.hpp
+++ b/src/modules/FFmpeg/VAAPIOpenGL.hpp
@@ -36,18 +36,18 @@ public:
     VAAPIOpenGL();
     ~VAAPIOpenGL();
 
-    QString name() const override;
+    QString name() const;
 
-    Format getFormat() const override;
-    bool isCopy() const override;
+    Format getFormat() const;
+    bool isCopy() const;
 
-    bool init(const int *widths, const int *heights, const SetTextureParamsFn &setTextureParamsFn) override;
-    void clear() override;
+    bool init(const int *widths, const int *heights, const SetTextureParamsFn &setTextureParamsFn);
+    void clear();
 
-    bool mapFrame(Frame &videoFrame) override;
-    quint32 getTexture(int plane) override;
+    bool mapFrame(Frame &videoFrame);
+    quint32 getTexture(int plane);
 
-    Frame getCpuFrame(const Frame &videoFrame) override;
+    Frame getCpuFrame(const Frame &videoFrame);
 
     /**/
 
diff --git a/src/modules/FFmpeg/VAAPIVulkan.cpp b/src/modules/FFmpeg/VAAPIVulkan.cpp
index af322676..6ece8742 100644
--- a/src/modules/FFmpeg/VAAPIVulkan.cpp
+++ b/src/modules/FFmpeg/VAAPIVulkan.cpp
@@ -101,7 +101,7 @@ void VAAPIVulkan::map(Frame &frame)
 
     auto &vkImage = m_images[id];
 
-    if (!vkImage || (vaField != VA_FRAME_PICTURE && m_vaapi->m_isMesaRadeon && m_vaapi->m_driverVersion >= QVersionNumber(23, 3, 0)))
+    if (!vkImage || (vaField != VA_FRAME_PICTURE && m_vaapi->m_isMesaRadeon && m_vaapi->m_driverVersion >= SimpleVersion(23, 3, 0)))
     {
         if (m_vaapi->m_mutex)
             m_vaapi->m_mutex->lock();
diff --git a/src/modules/FFmpeg/VAAPIVulkan.hpp b/src/modules/FFmpeg/VAAPIVulkan.hpp
index f9b8630c..344c9f4c 100644
--- a/src/modules/FFmpeg/VAAPIVulkan.hpp
+++ b/src/modules/FFmpeg/VAAPIVulkan.hpp
@@ -14,7 +14,7 @@ class Image;
 struct AVFrame;
 class VAAPI;
 
-class VAAPIVulkan final : public QmVk::HWInterop
+class VAAPIVulkan : public QmVk::HWInterop
 {
 public:
     VAAPIVulkan();
@@ -29,12 +29,12 @@ public:
         return m_vaapi;
     }
 
-    QString name() const override;
+    QString name() const;
 
-    void map(Frame &frame) override;
-    void clear() override;
+    void map(Frame &frame);
+    void clear();
 
-    SyncDataPtr sync(const std::vector<Frame> &frames, vk::SubmitInfo *submitInfo = nullptr) override;
+    SyncDataPtr sync(const std::vector<Frame> &frames, vk::SubmitInfo *submitInfo = nullptr);
 
 public:
     void insertAvailableSurface(uintptr_t id);
diff --git a/src/modules/FFmpeg/VTBOpenGL.cpp b/src/modules/FFmpeg/VTBOpenGL.cpp
index dc325ed7..145cf333 100644
--- a/src/modules/FFmpeg/VTBOpenGL.cpp
+++ b/src/modules/FFmpeg/VTBOpenGL.cpp
@@ -20,7 +20,7 @@
 
 #include <Frame.hpp>
 
-#include <QOpenGLContext>
+#include <QtOpenGL/QGLContext>
 #include <QImage>
 
 extern "C"
diff --git a/src/modules/FFmpeg/VTBOpenGL.hpp b/src/modules/FFmpeg/VTBOpenGL.hpp
index 19f44f1f..5d58ce92 100644
--- a/src/modules/FFmpeg/VTBOpenGL.hpp
+++ b/src/modules/FFmpeg/VTBOpenGL.hpp
@@ -22,25 +22,25 @@
 
 struct AVBufferRef;
 
-class VTBOpenGL final : public OpenGLHWInterop
+class VTBOpenGL : public OpenGLHWInterop
 {
 public:
     VTBOpenGL(AVBufferRef *hwDeviceBufferRef);
     ~VTBOpenGL();
 
-    QString name() const override;
+    QString name() const;
 
-    Format getFormat() const override;
-    bool isTextureRectangle() const override;
-    bool isCopy() const override;
+    Format getFormat() const;
+    bool isTextureRectangle() const;
+    bool isCopy() const;
 
-    bool init(const int *widths, const int *heights, const SetTextureParamsFn &setTextureParamsFn) override;
-    void clear() override;
+    bool init(const int *widths, const int *heights, const SetTextureParamsFn &setTextureParamsFn);
+    void clear();
 
-    bool mapFrame(Frame &videoFrame) override;
-    quint32 getTexture(int plane) override;
+    bool mapFrame(Frame &videoFrame);
+    quint32 getTexture(int plane);
 
-    Frame getCpuFrame(const Frame &videoFrame) override;
+    Frame getCpuFrame(const Frame &videoFrame);
 
 public:
     AVBufferRef *m_hwDeviceBufferRef = nullptr;
diff --git a/src/modules/FFmpeg/VkVideoVulkan.hpp b/src/modules/FFmpeg/VkVideoVulkan.hpp
index 906028fb..6a7da6ed 100644
--- a/src/modules/FFmpeg/VkVideoVulkan.hpp
+++ b/src/modules/FFmpeg/VkVideoVulkan.hpp
@@ -29,20 +29,20 @@ class Instance;
 class Image;
 }
 
-class VkVideoVulkan final : public QmVk::HWInterop
+class VkVideoVulkan : public QmVk::HWInterop
 {
 public:
     VkVideoVulkan(const std::shared_ptr<QmVk::Instance> &device);
     ~VkVideoVulkan();
 
-    QString name() const override;
+    QString name() const;
 
-    void map(Frame &frame) override;
-    void clear() override;
+    void map(Frame &frame);
+    void clear();
 
-    SyncDataPtr sync(const std::vector<Frame> &frames, vk::SubmitInfo *submitInfo = nullptr) override;
+    SyncDataPtr sync(const std::vector<Frame> &frames, vk::SubmitInfo *submitInfo = nullptr);
 
-    void updateInfo(const std::vector<Frame> &frames) override;
+    void updateInfo(const std::vector<Frame> &frames);
 
 public:
     void insertAvailableAvVkFrames(uintptr_t avVkFramePtr, int codedWidth, int codedHeight);
diff --git a/src/modules/FileAssociation/FileAssociation.hpp b/src/modules/FileAssociation/FileAssociation.hpp
index 3299a592..de139b7d 100644
--- a/src/modules/FileAssociation/FileAssociation.hpp
+++ b/src/modules/FileAssociation/FileAssociation.hpp
@@ -20,16 +20,16 @@
 
 #include <Module.hpp>
 
-class FileAssociation final : public Module
+class FileAssociation : public Module
 {
     Q_OBJECT
 public:
     FileAssociation();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 
     bool reallyFirsttime;
 private slots:
@@ -43,14 +43,14 @@ class QPushButton;
 class QGroupBox;
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_OBJECT
     friend class FileAssociation;
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
     void addExtension(const QString &, const bool, const bool isPlaylist = false);
 private slots:
     void selectAll();
diff --git a/src/modules/Inputs/Inputs.cpp b/src/modules/Inputs/Inputs.cpp
index 503d76cf..514869a3 100644
--- a/src/modules/Inputs/Inputs.cpp
+++ b/src/modules/Inputs/Inputs.cpp
@@ -305,7 +305,7 @@ void ModuleSettingsWidget::saveSettings()
     if (pcmExtsE->text().isEmpty())
         pcmExtsE->setText(g_standartExts);
     sets().set("PCM", pcmB->isChecked());
-    sets().set("PCM/extensions", pcmExtsE->text().split(';', Qt::SkipEmptyParts));
+    sets().set("PCM/extensions", pcmExtsE->text().split(';', QString::SkipEmptyParts));
     for (int i = 0; i < formatB.size(); ++i)
         if (formatB[i]->isChecked())
         {
diff --git a/src/modules/Inputs/Inputs.hpp b/src/modules/Inputs/Inputs.hpp
index 19606b72..065a2f65 100644
--- a/src/modules/Inputs/Inputs.hpp
+++ b/src/modules/Inputs/Inputs.hpp
@@ -20,18 +20,18 @@
 
 #include <Module.hpp>
 
-class Inputs final : public Module
+class Inputs : public Module
 {
     Q_OBJECT
 public:
     Inputs();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    QList<QAction *> getAddActions() override;
+    QList<QAction *> getAddActions();
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 
     QIcon toneIcon, pcmIcon;
 private slots:
@@ -43,7 +43,7 @@ private slots:
 #include <QSpinBox>
 #include <QDialog>
 
-class HzW final : public QWidget
+class HzW : public QWidget
 {
 public:
     HzW(int, const QStringList &);
@@ -60,7 +60,7 @@ private:
 
 class QGridLayout;
 
-class AddD final : public QDialog
+class AddD : public QDialog
 {
     Q_OBJECT
 public:
@@ -95,7 +95,7 @@ class QGroupBox;
 class QCheckBox;
 class QLineEdit;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_OBJECT
 public:
@@ -103,7 +103,7 @@ public:
 private slots:
     void applyFreqs();
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     AddD *toneGenerator;
     QGroupBox *pcmB;
diff --git a/src/modules/Inputs/PCM.hpp b/src/modules/Inputs/PCM.hpp
index 044876ea..98258e69 100644
--- a/src/modules/Inputs/PCM.hpp
+++ b/src/modules/Inputs/PCM.hpp
@@ -24,25 +24,25 @@
 
 class Reader;
 
-class PCM final : public Demuxer
+class PCM : public Demuxer
 {
 public:
     enum FORMAT {PCM_U8, PCM_S8, PCM_S16, PCM_S24, PCM_S32, PCM_FLT, FORMAT_COUNT};
 
     PCM(Module &);
 private:
-    bool set() override;
+    bool set();
 
-    QString name() const override;
-    QString title() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const;
+    QString title() const;
+    double length() const;
+    int bitrate() const;
 
-    bool seek(double, bool) override;
-    bool read(Packet &, int &) override;
-    void abort() override;
+    bool seek(double, bool);
+    bool read(Packet &, int &);
+    void abort();
 
-    bool open(const QString &) override;
+    bool open(const QString &);
 
     /**/
 
diff --git a/src/modules/Inputs/ToneGenerator.cpp b/src/modules/Inputs/ToneGenerator.cpp
index 701b99e8..59457943 100644
--- a/src/modules/Inputs/ToneGenerator.cpp
+++ b/src/modules/Inputs/ToneGenerator.cpp
@@ -21,7 +21,11 @@
 #include <Functions.hpp>
 #include <Packet.hpp>
 
-#include <QUrlQuery>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QUrlQuery>
+#else
+    #include <QUrl>
+#endif
 
 #include <cmath>
 
@@ -131,12 +135,22 @@ bool ToneGenerator::open(const QString &entireUrl)
         return true;
     }
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     srate = QUrlQuery(url).queryItemValue("samplerate").toUInt();
     if (!srate)
         srate = 44100;
 
     freqs.clear();
-    for (const QString &freq : QUrlQuery(url).queryItemValue("freqs").split(',', Qt::SkipEmptyParts))
+    for (const QString &freq : QUrlQuery(url).queryItemValue("freqs").split(',', QString::SkipEmptyParts))
+#else
+    // Qt4: No QUrlQuery, use QUrl methods directly
+    srate = url.queryItemValue("samplerate").toUInt();
+    if (!srate)
+        srate = 44100;
+
+    freqs.clear();
+    for (const QString &freq : url.queryItemValue("freqs").split(',', QString::SkipEmptyParts))
+#endif
         freqs += freq.toInt();
     if (freqs.isEmpty())
     {
diff --git a/src/modules/Inputs/ToneGenerator.hpp b/src/modules/Inputs/ToneGenerator.hpp
index cdda11ba..982db75e 100644
--- a/src/modules/Inputs/ToneGenerator.hpp
+++ b/src/modules/Inputs/ToneGenerator.hpp
@@ -22,28 +22,28 @@
 
 #include <atomic>
 
-class ToneGenerator final : public Demuxer
+class ToneGenerator : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(ToneGenerator)
 public:
     ToneGenerator(Module &);
 
-    bool set() override;
+    bool set();
 private:
-    bool metadataChanged() const override;
+    bool metadataChanged() const;
 
-    QString name() const override;
-    QString title() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const;
+    QString title() const;
+    double length() const;
+    int bitrate() const;
 
-    bool dontUseBuffer() const override;
+    bool dontUseBuffer() const;
 
-    bool seek(double, bool) override;
-    bool read(Packet &, int &) override;
-    void abort() override;
+    bool seek(double, bool);
+    bool read(Packet &, int &);
+    void abort();
 
-    bool open(const QString &) override;
+    bool open(const QString &);
 
     /**/
 
diff --git a/src/modules/Notify/Notify.hpp b/src/modules/Notify/Notify.hpp
index ddd58164..28038492 100644
--- a/src/modules/Notify/Notify.hpp
+++ b/src/modules/Notify/Notify.hpp
@@ -20,16 +20,16 @@
 
 #include <Module.hpp>
 
-class Notify final : public Module
+class Notify : public Module
 {
 public:
     Notify();
 
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
@@ -41,7 +41,7 @@ class QCheckBox;
 class QGroupBox;
 class QLineEdit;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 
@@ -49,7 +49,7 @@ public:
     ModuleSettingsWidget(Module &module);
 
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QGroupBox *m_notify;
     QDoubleSpinBox *m_timeoutSB;
diff --git a/src/modules/Notify/NotifyExtension.cpp b/src/modules/Notify/NotifyExtension.cpp
index 1015e2b3..a7c66992 100644
--- a/src/modules/Notify/NotifyExtension.cpp
+++ b/src/modules/Notify/NotifyExtension.cpp
@@ -35,7 +35,7 @@ NotifyService::NotifyService(Settings &settings) :
 {
     if (settings.getBool("ShowTitle"))
     {
-        connect(&QMPlay2Core, &QMPlay2CoreClass::updatePlaying, this, &NotifyService::updatePlaying);
+        connect(&QMPlay2Core, SIGNAL(updatePlaying(bool, const QString &, const QString &, const QString &, int, bool, const QString &, const QString &)), this, SLOT(updatePlaying(bool, const QString &, const QString &, const QString &, int, bool, const QString &, const QString &)));
 
         //"coverDataFromMediaFile()" and "coverFile()" are emited before "updatePlaying()"
         connect(&QMPlay2Core, SIGNAL(coverDataFromMediaFile(QByteArray)), this, SLOT(coverDataFromMediaFile(QByteArray)));
diff --git a/src/modules/Notify/NotifyExtension.hpp b/src/modules/Notify/NotifyExtension.hpp
index 1a86ad97..6244b304 100644
--- a/src/modules/Notify/NotifyExtension.hpp
+++ b/src/modules/Notify/NotifyExtension.hpp
@@ -22,7 +22,7 @@
 
 #include <memory>
 
-class NotifyService final : public QObject
+class NotifyService : public QObject
 {
     Q_OBJECT
 
@@ -30,10 +30,9 @@ public:
     NotifyService(Settings &settings);
     ~NotifyService();
 
-private:
+private slots:
     void updatePlaying(bool play, const QString &title, const QString &artist, const QString &album, int, bool, const QString &fileName, const QString &url);
 
-private slots:
     void coverDataFromMediaFile(const QByteArray &cover);
     void coverFile(const QString &fileName);
 
@@ -48,14 +47,14 @@ private:
 
 /**/
 
-class NotifyExtension final : public QMPlay2Extensions
+class NotifyExtension : public QMPlay2Extensions
 {
 public:
     NotifyExtension(Module &module);
     ~NotifyExtension();
 
 private:
-    bool set() override;
+    bool set();
 
     std::unique_ptr<NotifyService> m_notifyService;
 };
diff --git a/src/modules/OpenMPT/OpenMPT.cpp b/src/modules/OpenMPT/OpenMPT.cpp
index c4665e91..0a38bedb 100644
--- a/src/modules/OpenMPT/OpenMPT.cpp
+++ b/src/modules/OpenMPT/OpenMPT.cpp
@@ -84,7 +84,7 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module)
     m_stereoSeparation = new QSpinBox;
     m_stereoSeparation->setRange(0, 200);
     m_stereoSeparation->setValue(sets().getInt("StereoSeparation"));
-    m_stereoSeparation->setSuffix(QStringLiteral("%"));
+    m_stereoSeparation->setSuffix(QString("%"));
 
     m_interpolationFilter = new QComboBox;
     m_interpolationFilter->addItem(tr("Default"), 0);
@@ -124,7 +124,11 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module)
     auto updateVisSettingsVisibility = [this](int index) {
         m_visSettingsWidget->setVisible(index == 1);
     };
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     connect(m_visMode, qOverload<int>(&QComboBox::currentIndexChanged), this, updateVisSettingsVisibility);
+#else
+    connect(m_visMode, SIGNAL(currentIndexChanged(int)), this, SLOT(visModeChanged(int)));
+#endif
     updateVisSettingsVisibility(m_visMode->currentIndex());
 
     auto *layout = new QFormLayout(this);
@@ -141,8 +145,17 @@ void ModuleSettingsWidget::saveSettings()
     sets().set("Enabled", m_enabled->isChecked());
     sets().set("SubsongMode", m_subsongMode->currentIndex());
     sets().set("StereoSeparation", m_stereoSeparation->value());
-    sets().set("InterpolationFilter", m_interpolationFilter->currentData().toInt());
+    sets().set("InterpolationFilter", m_interpolationFilter->itemData(m_interpolationFilter->currentIndex()).toInt());
     sets().set("VisMode", m_visMode->currentIndex());
     sets().set("VisChannels", m_visChannels->value());
     sets().set("VisRows", m_visRows->value());
 }
+
+// Qt4: Helper slot implementations
+
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+void ModuleSettingsWidget::visModeChanged(int index)
+{
+    m_visSettingsWidget->setVisible(index == 1);
+}
+#endif
diff --git a/src/modules/OpenMPT/OpenMPT.hpp b/src/modules/OpenMPT/OpenMPT.hpp
index 0445bcff..d98ad1d9 100644
--- a/src/modules/OpenMPT/OpenMPT.hpp
+++ b/src/modules/OpenMPT/OpenMPT.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class OpenMPT final : public Module
+class OpenMPT : public Module
 {
 public:
     OpenMPT();
 
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
-    SettingsWidget *getSettingsWidget() override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
+    SettingsWidget *getSettingsWidget();
 
 private:
     QIcon m_modIcon{":/MOD.svg"};
@@ -36,21 +36,28 @@ private:
 
 /**/
 
-#include <QCoreApplication>
-
 class QCheckBox;
 class QComboBox;
 class QSpinBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
-    Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
+    // XXX(qt4-port): Changed from Q_DECLARE_TR_FUNCTIONS to Q_OBJECT (which also
+    // provides tr()) because this class now needs a private slot for Qt4's
+    // old-style SIGNAL/SLOT connect (see visModeChanged() below); Q_OBJECT is
+    // required for moc to generate the slot dispatch under Qt4.
+    Q_OBJECT
 
 public:
     ModuleSettingsWidget(Module &);
 
 private:
-    void saveSettings() override;
+    void saveSettings();
+
+#if QT_VERSION < 0x050000
+private slots:
+    void visModeChanged(int index);
+#endif
 
 private:
     QCheckBox *m_enabled{nullptr};
diff --git a/src/modules/OpenMPT/OpenMPTDemux.cpp b/src/modules/OpenMPT/OpenMPTDemux.cpp
index 68f42187..990ab023 100644
--- a/src/modules/OpenMPT/OpenMPTDemux.cpp
+++ b/src/modules/OpenMPT/OpenMPTDemux.cpp
@@ -214,7 +214,7 @@ Playlist::Entries OpenMPDemux::fetchTracks(const QString &url, bool &ok)
         m_module->select_subsong(i);
 
         Playlist::Entry entry;
-        entry.url = QString::fromLatin1(DemuxerName) + QStringLiteral("://") + QChar('{') + url + QStringLiteral("}") + QString::number(i);
+        entry.url = QString::fromLatin1(DemuxerName) + QString("://") + QChar('{') + url + QString("}") + QString::number(i);
         entry.name = formatSubsongTitle(i, subsongNames, m_moduleTitle).first;
         entry.length = m_module->get_duration_seconds();
 
@@ -382,5 +382,5 @@ std::pair<QString, QString> OpenMPDemux::formatSubsongTitle(int subsong, const s
         subsongTitle = QString::fromStdString(subsongNames[subsong]).trimmed();
     if (subsongTitle.isEmpty())
         subsongTitle = rawTitle;
-    return {tr("Track %1").arg(subsong + 1, 2, 10, QChar('0')) + QStringLiteral(" - ") + subsongTitle, subsongTitle};
+    return {tr("Track %1").arg(subsong + 1, 2, 10, QChar('0')) + QString(" - ") + subsongTitle, subsongTitle};
 }
diff --git a/src/modules/OpenMPT/OpenMPTDemux.hpp b/src/modules/OpenMPT/OpenMPTDemux.hpp
index 09f6c920..3bd43a1e 100644
--- a/src/modules/OpenMPT/OpenMPTDemux.hpp
+++ b/src/modules/OpenMPT/OpenMPTDemux.hpp
@@ -31,7 +31,7 @@ namespace openmpt {
     class module;
 }
 
-class OpenMPDemux final : public Demuxer
+class OpenMPDemux : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(OpenMPDemux)
 
@@ -46,25 +46,25 @@ public:
     OpenMPDemux(Module &);
 
 private:
-    ~OpenMPDemux() override;
+    ~OpenMPDemux();
 
-    bool set() override;
+    bool set();
 
-    QString name() const override;
-    QString title() const override;
-    QList<QMPlay2Tag> tags() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const;
+    QString title() const;
+    QList<QMPlay2Tag> tags() const;
+    double length() const;
+    int bitrate() const;
 
-    bool dontUseBuffer() const override;
+    bool dontUseBuffer() const;
 
-    bool seek(double, bool) override;
-    bool read(Packet &, int &) override;
-    void abort() override;
+    bool seek(double, bool);
+    bool read(Packet &, int &);
+    void abort();
 
-    Playlist::Entries fetchTracks(const QString &url, bool &ok) override;
+    Playlist::Entries fetchTracks(const QString &url, bool &ok);
 
-    bool open(const QString &urlArg) override;
+    bool open(const QString &urlArg);
 
     void openModule(const QString &url);
 
diff --git a/src/modules/OpenMPT/OpenMPTVisBase.cpp b/src/modules/OpenMPT/OpenMPTVisBase.cpp
index 997e1526..7874bd96 100644
--- a/src/modules/OpenMPT/OpenMPTVisBase.cpp
+++ b/src/modules/OpenMPT/OpenMPTVisBase.cpp
@@ -29,7 +29,7 @@ int OpenMPTVisBase::height() const
 
 QFont OpenMPTVisBase::visFont(int pt)
 {
-    QFont font(QStringLiteral("Monospace"), pt);
+    QFont font(QString("Monospace"), pt);
     font.setStyleHint(QFont::Monospace);
     font.setFixedPitch(true);
     return font;
diff --git a/src/modules/OpenMPT/OpenMPTVisPatterns.cpp b/src/modules/OpenMPT/OpenMPTVisPatterns.cpp
index d1fdff5e..64357f18 100644
--- a/src/modules/OpenMPT/OpenMPTVisPatterns.cpp
+++ b/src/modules/OpenMPT/OpenMPTVisPatterns.cpp
@@ -34,7 +34,12 @@ static int computeMaxCellWidth(openmpt::module *module, int pattern, const QFont
     for (int ch = 0; ch < numChannels; ++ch)
     {
         const std::string text = module->format_pattern_row_channel(pattern, 0, ch);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 11, 0)
         const int w = fm.horizontalAdvance(QString::fromStdString(text)) + fm.horizontalAdvance("X");
+#else
+        // Qt4: QFontMetrics::horizontalAdvance() was added in Qt 5.11; use width() instead
+        const int w = fm.width(QString::fromStdString(text)) + fm.width("X");
+#endif
         if (w > maxW)
             maxW = w;
     }
@@ -80,7 +85,12 @@ OpenMPTVisPatterns::OpenMPTVisPatterns(openmpt::module *module, int channels, in
     m_rowHeight = fm.height() + 2;
     m_height = m_rows * m_rowHeight;
     m_maxCellWidth = maxCellWidth;
+#if QT_VERSION >= QT_VERSION_CHECK(5, 11, 0)
     m_charWidth = fm.horizontalAdvance("X");
+#else
+    // Qt4: QFontMetrics::horizontalAdvance() was added in Qt 5.11; use width() instead
+    m_charWidth = fm.width("X");
+#endif
 
     for (int i = 33; i <= 126; ++i)
     {
diff --git a/src/modules/OpenMPT/OpenMPTVisPatterns.hpp b/src/modules/OpenMPT/OpenMPTVisPatterns.hpp
index 99150c77..8a00690a 100644
--- a/src/modules/OpenMPT/OpenMPTVisPatterns.hpp
+++ b/src/modules/OpenMPT/OpenMPTVisPatterns.hpp
@@ -27,8 +27,8 @@ class OpenMPTVisPatterns : public OpenMPTVisBase
 public:
     OpenMPTVisPatterns(openmpt::module *module, int channels, int rows);
 
-    Frame render(openmpt::module *module) override;
-    void reset() override;
+    Frame render(openmpt::module *module);
+    void reset();
 
 private:
     int m_channels{0};
diff --git a/src/modules/OpenMPT/OpenMPTVisSamples.cpp b/src/modules/OpenMPT/OpenMPTVisSamples.cpp
index 0f84632f..49c867e7 100644
--- a/src/modules/OpenMPT/OpenMPTVisSamples.cpp
+++ b/src/modules/OpenMPT/OpenMPTVisSamples.cpp
@@ -20,6 +20,8 @@
 
 #include <QPainter>
 
+#include <cmath>
+
 #include <libopenmpt/libopenmpt.hpp>
 
 extern "C" {
@@ -43,7 +45,12 @@ static QFont computeFitFont(int nameWidth, int &outCharWidth, int &outAscent)
         fm = QFontMetrics(font);
     }
 
-    outCharWidth = fm.horizontalAdvance(QStringLiteral("X"));
+#if QT_VERSION >= QT_VERSION_CHECK(5, 11, 0)
+    outCharWidth = fm.horizontalAdvance(QString("X"));
+#else
+    // Qt4: QFontMetrics::horizontalAdvance() was added in Qt 5.11; use width() instead
+    outCharWidth = fm.width(QString("X"));
+#endif
     outAscent = fm.ascent();
     return font;
 }
diff --git a/src/modules/OpenMPT/OpenMPTVisSamples.hpp b/src/modules/OpenMPT/OpenMPTVisSamples.hpp
index 2a2f3280..f4f43974 100644
--- a/src/modules/OpenMPT/OpenMPTVisSamples.hpp
+++ b/src/modules/OpenMPT/OpenMPTVisSamples.hpp
@@ -29,8 +29,8 @@ class OpenMPTVisSamples : public OpenMPTVisBase
 public:
     OpenMPTVisSamples(openmpt::module *module);
 
-    Frame render(openmpt::module *module) override;
-    void reset() override;
+    Frame render(openmpt::module *module);
+    void reset();
 
 private:
     int m_numSamples{0};
